<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterUpgrade
{
    protected $container;

    public function run($container)
    {
        $entityManager = $container->get('entityManager');
        $config = $container->get('config');

        $scheduledJob = $entityManager->getEntity('ScheduledJob');
        $scheduledJob->set(array(
            'name' => 'Control Knowledge Base Article Status',
            'job' => 'ControlKnowledgeBaseArticleStatus',
            'status' => 'Active',
            'scheduling' => '10 1 * * *'
        ));
        $entityManager->saveEntity($scheduledJob);

        $userList = $entityManager->getRepository('User')->find();

        foreach ($userList as $user) {
            $preferences = $entityManager->getEntity('Preferences', $user->id);
            $dashboardLayout = $preferences->get('dashboardLayout');

            $dashboardLayoutNew = [];
            foreach ($dashboardLayout as $i => $tab) {
                $tabNew = (object) [];
                $tabNew->name = $tab->name;
                $tabNew->layout = [];
                foreach ($tab->layout as $i => $column) {
                    foreach ($column as $j => $item) {
                        $item->x = $i * 2;
                        $item->y = $j * 2;
                        $item->height = 2;
                        $item->width = 2;
                        $tabNew->layout[] = $item;
                    }
                }
                $dashboardLayoutNew[] = $tabNew;
            }

            $o = $preferences->get('dashletOptions');
            $preferences->set('dashletsOptions', $o);
            $preferences->clear('dashletOptions');

            $dashboardLayout = $preferences->set('dashboardLayout', $dashboardLayoutNew);
            $entityManager->saveEntity($preferences);
        }

        $languageList = $config->get('languageList', []);
        $languageList[] = 'cs_CZ';
        $config->set('languageList', $languageList);
        $config->save();
    }
}
